#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <assert.h>


void GetPrimaryIp(char* buffer, size_t buflen) 
{
  int sock = socket(AF_INET, SOCK_DGRAM, 0);
  const char* kGoogleDnsIp = "8.8.8.8";
  u_int16_t kDnsPort = 53;
  struct sockaddr_in serv;
  int err;
  sockaddr_in name;
  socklen_t namelen = sizeof(name);
  const char* p;

  buffer[0] = '\0';
  memset(&serv, 0, sizeof(serv));
  serv.sin_family = AF_INET;
  serv.sin_addr.s_addr = inet_addr(kGoogleDnsIp);
  serv.sin_port = htons(kDnsPort);

  err = connect(sock, (const sockaddr*) &serv, sizeof(serv));
  err = getsockname(sock, (sockaddr*) &name, &namelen);

  p = inet_ntop(AF_INET, &name.sin_addr, buffer, buflen);

  close(sock);
}

int main(int argc, char* argv[]) {
  char buf[256];

  GetPrimaryIp(buf, sizeof(buf));

  print("%s\n", buf);
  return(0);
}
